Part ShapeFromMesh: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
(Module to Workbench renaming.)
(39 intermediate revisions by 8 users not shown)
Line 1: Line 1:
<languages/>
<translate>
<translate>
<!--T:1-->
{{Template:UnfinishedDocu}}


<!--T:7-->
{{Docnav
|[[Part_BoxSelection|BoxSelection]]
|[[Part_PointsFromMesh|PointsFromMesh]]
|[[Part_Workbench|Part]]
|IconL=Part_BoxSelection.svg
|IconR=Part_PointsFromMesh.svg
|IconC=Workbench_Part.svg
}}


<!--T:2-->
<!--T:2-->
{{GuiCommand
{{GuiCommand|Name=Part ShapeFromMesh‏‎|MenuLocation=Part → Shape from Mesh|Workbenches=[[Part Workbench|Part]]|SeeAlso=}}
|Name=Part ShapeFromMesh‏‎
|MenuLocation=Part → Create shape from mesh...
|Workbenches=[[Part_Workbench|Part]]
|SeeAlso=[[Part_MakeSolid|Part ConvertToSolid]], [[Part_RefineShape|Part RefineShape]], [[Part_PointsFromMesh|Part PointsFromMesh]]
}}


==Introduction== <!--T:3-->
==Introduction== <!--T:14-->


==Usage== <!--T:4-->
<!--T:3-->
The {{Button|[[Image:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|Part ShapeFromMesh]]}} command creates a shape from a [[Mesh|mesh object]]. Mesh objects have limited editing capabilities in FreeCAD, converting them to [[Shape|shapes]] will allow their use with many more boolean and modification tools.

<!--T:21-->
The inverse operation is {{Button|[[File:Mesh_FromPartShape.svg|16px]] [[Mesh_FromPartShape|Mesh FromPartShape]]}} from the [[File:Workbench_Mesh.svg|24px]] [[Mesh_Workbench|Mesh Workbench]].

==Usage== <!--T:15-->

<!--T:4-->
# Select the mesh object in the [[tree_view|tree view]].
# Go to the menu, {{MenuCommand|Part → [[File:Part_ShapeFromMesh.svg|16px]] Create shape from mesh}}.
# A popup-menu will ask for the tolerance for sewing shape; the default value is {{Value|0.1}}.
# A [[Shape|shape]] from the mesh object is created as a separate new object.


<!--T:5-->
<!--T:5-->
Analyzing and repairing of the mesh, if needed, should be done manually before launching {{Button|[[File:Part_ShapeFromMesh.svg|16px]] [[Part_ShapeFromMesh|ShapeFromMesh]]}}. Appropriate tools for this task are available in the [[File:Workbench_Mesh.svg|24px]] [[Mesh_Workbench|Mesh Workbench]].
[[Category:UnfinishedDocu]]

<!--T:16-->
After creation of a [[Shape|Shape]], it may be useful to use {{Button|[[Part_MakeSolid|Convert to solid]]}} (necessary for [[Part_Boolean|boolean operations]]) and {{Button|[[File:Part_RefineShape.svg|16px]] [[Part_RefineShape|Refine shape]]}}.

== Links == <!--T:17-->

<!--T:18-->
* [https://www.youtube.com/watch?v=5lwENZeNiNg&feature=youtu.be Edit STL Files In FreeCAD] video by AllVisuals4U.

==Scripting== <!--T:13-->

<!--T:19-->
Creating a [[Shape|Shape]] from a [[Mesh|Mesh]] can be done by using the {{incode|makeShapeFromMesh}} method from a [[Part_TopoShape|Part TopoShape]]; you need to specify the source mesh and tolerance, and assign the result to a new [[Part_Feature|Part Feature]] object.

<!--T:20-->
Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.

</translate>
{{Code|code=
import FreeCAD as App
import Part

doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()

solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)

solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()
}}
<translate>


<!--T:8-->
{{Docnav
|[[Part_BoxSelection|BoxSelection]]
|[[Part_PointsFromMesh|PointsFromMesh]]
|[[Part_Workbench|Part]]
|IconL=Part_BoxSelection.svg
|IconR=Part_PointsFromMesh.svg
|IconC=Workbench_Part.svg
}}


</translate>
</translate>
{{Part Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}
{{clear}}
<languages/>

Revision as of 12:58, 25 August 2021

Part ShapeFromMesh‏‎

Menu location
Part → Create shape from mesh...
Workbenches
Part
Default shortcut
None
Introduced in version
-
See also
Part ConvertToSolid, Part RefineShape, Part PointsFromMesh

Introduction

The Part ShapeFromMesh command creates a shape from a mesh object. Mesh objects have limited editing capabilities in FreeCAD, converting them to shapes will allow their use with many more boolean and modification tools.

The inverse operation is Mesh FromPartShape from the Mesh Workbench.

Usage

  1. Select the mesh object in the tree view.
  2. Go to the menu, Part → Create shape from mesh.
  3. A popup-menu will ask for the tolerance for sewing shape; the default value is 0.1.
  4. A shape from the mesh object is created as a separate new object.

Analyzing and repairing of the mesh, if needed, should be done manually before launching ShapeFromMesh. Appropriate tools for this task are available in the Mesh Workbench.

After creation of a Shape, it may be useful to use Convert to solid (necessary for boolean operations) and Refine shape.

Links

Scripting

Creating a Shape from a Mesh can be done by using the makeShapeFromMesh method from a Part TopoShape; you need to specify the source mesh and tolerance, and assign the result to a new Part Feature object.

Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.

import FreeCAD as App
import Part

doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()

solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)

solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()